Index: trunk/src/VBox/Additions/WINNT/Graphics/Display/VBoxDisp.rc
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/Display/VBoxDisp.rc	(revision 7392)
+++ trunk/src/VBox/Additions/WINNT/Graphics/Display/VBoxDisp.rc	(revision 8060)
@@ -1,3 +1,4 @@
 #include <windows.h>
+#include <VBox/version.h>
 
 LANGUAGE LANG_ENGLISH, SUBLANG_ENGLISH_US
@@ -16,11 +17,11 @@
       BLOCK "040904b0"
       BEGIN
-         VALUE "CompanyName",      "innotek GmbH\0"
-         VALUE "FileDescription",  "VirtualBox Display Driver\0"
+         VALUE "CompanyName",      VBOX_RC_COMPANY_NAME
+         VALUE "FileDescription",  "xVM VirtualBox Display Driver\0"
          VALUE "FileVersion",      VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD "." VBOX_SVN_REV "\0"
-         VALUE "InternalName",     "VBoxDisp.dll\0"
-         VALUE "LegalCopyright",   "(C) 2004-2007 innotek GmbH\0"
+         VALUE "InternalName",     "VBoxDisp\0"
+         VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
          VALUE "OriginalFilename", "VBoxDisp.dll\0"
-         VALUE "ProductName",      "VirtualBox Guest Tools\0"
+         VALUE "ProductName",      "xVM VirtualBox Guest Additions\0"
          VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD "." VBOX_SVN_REV "\0"
       END
Index: trunk/src/VBox/Additions/WINNT/Graphics/Miniport/Mirror/vrdpdd.inf
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/Miniport/Mirror/vrdpdd.inf	(revision 7392)
+++ trunk/src/VBox/Additions/WINNT/Graphics/Miniport/Mirror/vrdpdd.inf	(revision 8060)
@@ -18,5 +18,5 @@
 [Version]
 Signature="$WINDOWS NT$"
-Provider=%innotek%
+Provider=%Sun%
 ClassGUID={4D36E968-E325-11CE-BFC1-08002BE10318}
 Class=Display
@@ -32,5 +32,5 @@
 
 [Manufacturer]
-%innotek%=vrdpdd.Mfg,NT.5.1
+%Sun%=vrdpdd.Mfg,NT.5.1
 
 [vrdpdd.Mfg]
@@ -38,5 +38,5 @@
 
 [vrdpdd.Mfg.NT.5.1]
-%DevDesc% = vrdpdd, innotek_vrdpdd
+%DevDesc% = vrdpdd, sun_vrdpdd
 
 ;
@@ -130,5 +130,5 @@
 REG_DWORD      = 0x00010001
 SERVICEROOT    = "System\CurrentControlSet\Services"
-DevDesc      = "innotek VirtualBox Mirror Driver"
+DevDesc        = "Sun xVM VirtualBox Mirror Driver"
 
 ;
@@ -136,5 +136,5 @@
 ;
 
-DiskId       = "innotek Mirror Driver Installation DISK (VIDEO)"
+DiskId       = "Sun xVM Mirror Driver Installation DISK (VIDEO)"
 GraphAdap    = "Graphics Adapter"
-innotek      = "innotek"
+Sun          = "Sun Microsystems, Inc."
Index: trunk/src/VBox/Additions/WINNT/Graphics/Miniport/Mirror/vrdpvd.rc
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/Miniport/Mirror/vrdpvd.rc	(revision 7392)
+++ trunk/src/VBox/Additions/WINNT/Graphics/Miniport/Mirror/vrdpvd.rc	(revision 8060)
@@ -1,3 +1,4 @@
 #include <windows.h>
+#include <VBox/version.h>
 
 LANGUAGE LANG_ENGLISH, SUBLANG_ENGLISH_US
@@ -5,5 +6,5 @@
 VS_VERSION_INFO VERSIONINFO
    FILEVERSION          VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
-   PRODUCTVERSION	VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
+   PRODUCTVERSION       VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
    FILEFLAGSMASK        0x3fL
    FILEFLAGS            0x0L
@@ -16,11 +17,11 @@
       BLOCK "040904b0"
       BEGIN
-         VALUE "CompanyName",      "innotek GmbH"
+         VALUE "CompanyName",      VBOX_RC_COMPANY_NAME
          VALUE "FileDescription",  "VirtualBox Mirror Video Driver\0"
          VALUE "FileVersion",	   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD "\0"
-         VALUE "InternalName",     "vrdpvd.sys\0"
-         VALUE "LegalCopyright",   "(C) 2004-2007 innotek GmbH\0"
-         VALUE "OriginalFilename", "vrdpvd.sys\0"
-         VALUE "ProductName",	   "VirtualBox Guest Tools\0"
+         VALUE "InternalName",     "VRdpvd\0"
+         VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
+         VALUE "OriginalFilename", "VRdpvd.sys\0"
+         VALUE "ProductName",	   "xVM VirtualBox Guest Additions\0"
          VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD "\0"
       END
Index: trunk/src/VBox/Additions/WINNT/Graphics/Miniport/VBoxVideo.inf
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/Miniport/VBoxVideo.inf	(revision 7392)
+++ trunk/src/VBox/Additions/WINNT/Graphics/Miniport/VBoxVideo.inf	(revision 8060)
@@ -42,24 +42,25 @@
 
 [VBoxVideo.Services]
-AddService=vboxvideo, 0x00000002, vboxvideo_Service_Inst, vboxvideo_EventLog_Inst
+AddService=VBoxVideo, 0x00000002, VBoxVideo_Service_Inst, VBoxVideo_EventLog_Inst
 
-[vboxvideo_Service_Inst]
-ServiceType=1                   ; SERVICE_KERNEL_DRIVER
-StartType=1                     ; SERVICE_SYSTEM_START
-ErrorControl=0                  ; SERVICE_ERROR_IGNORE
-LoadOrderGroup=Video
-ServiceBinary=%12%\VBoxVideo.sys
+[VBoxVideo_Service_Inst]
+DisplayName    = %VBoxVideo.SvcDesc%
+ServiceType    = 1                   ; SERVICE_KERNEL_DRIVER
+StartType      = 1                   ; SERVICE_SYSTEM_START
+ErrorControl   = 0                   ; SERVICE_ERROR_IGNORE
+LoadOrderGroup = Video
+ServiceBinary  = %12%\VBoxVideo.sys
 
-[vboxvideo_EventLog_Inst]
-AddReg = vboxvideo_EventLog_AddReg
+[VBoxVideo_EventLog_Inst]
+AddReg = VBoxVideo_EventLog_AddReg
 
-[vboxvideo_EventLog_AddReg]
+[VBoxVideo_EventLog_AddReg]
 HKR,,EventMessageFile,0x00020000,"%SystemRoot%\System32\IoLogMsg.dll;%SystemRoot%\System32\drivers\VBoxVideo.sys"
 HKR,,TypesSupported,0x00010001,7
 
 [VBoxVideo.SoftwareSettings]
-AddReg = vboxvideo_SoftwareDeviceSettings
+AddReg = VBoxVideo_SoftwareDeviceSettings
 
-[vboxvideo_SoftwareDeviceSettings]
+[VBoxVideo_SoftwareDeviceSettings]
 HKR,, InstalledDisplayDrivers, %REG_MULTI_SZ%, VBoxDisp
 ; Set 'Full' hardware acceleration up. On W2003 the level is by default None=5, leading to software mouse cursor
@@ -84,5 +85,6 @@
 REG_DWORD = 0x00010001
 
-Provider = "innotek GmbH"
-VBoxVideo.Disk = "VirtualBox Video Driver Disk"
-VBoxVideo.SvcDesc = "VirtualBox Graphics Adapter"
+Provider = "Sun Microsystems, Inc."
+VBoxVideo.DeviceDesc = "xVM VirtualBox Graphics Adapter"
+VBoxVideo.Disk = "xVM VirtualBox Video Driver Disk"
+VBoxVideo.SvcDesc = "xVM VirtualBox Graphics Adapter"
Index: trunk/src/VBox/Additions/WINNT/Graphics/Miniport/VBoxVideo.rc
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/Miniport/VBoxVideo.rc	(revision 7392)
+++ trunk/src/VBox/Additions/WINNT/Graphics/Miniport/VBoxVideo.rc	(revision 8060)
@@ -1,3 +1,4 @@
 #include <windows.h>
+#include <VBox/version.h>
 
 LANGUAGE LANG_ENGLISH, SUBLANG_ENGLISH_US
@@ -16,11 +17,11 @@
       BLOCK "040904b0"
       BEGIN
-         VALUE "CompanyName",      "innotek GmbH\0"
-         VALUE "FileDescription",  "VirtualBox Video Driver\0"
+         VALUE "CompanyName",      VBOX_RC_COMPANY_NAME
+         VALUE "FileDescription",  "xVM VirtualBox Video Driver\0"
          VALUE "FileVersion",	   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD "." VBOX_SVN_REV "\0"
-         VALUE "InternalName",     "vboxvideo\0"
-         VALUE "LegalCopyright",   "(C) 2004-2007 innotek GmbH\0"
-         VALUE "OriginalFilename", "vboxvideo.sys\0"
-         VALUE "ProductName",	   "VirtualBox Video Driver\0"
+         VALUE "InternalName",     "VBoxVideo\0"
+         VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
+         VALUE "OriginalFilename", "VBoxVideo.sys\0"
+         VALUE "ProductName",	   "xVM VirtualBox Guest Additions\0"
          VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD "." VBOX_SVN_REV "\0"
       END
Index: trunk/src/VBox/Additions/WINNT/Graphics/OpenGL/VBoxOGL.rc
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/OpenGL/VBoxOGL.rc	(revision 7392)
+++ trunk/src/VBox/Additions/WINNT/Graphics/OpenGL/VBoxOGL.rc	(revision 8060)
@@ -14,4 +14,5 @@
  */
 #include <windows.h>
+#include <VBox/version.h>
 
 LANGUAGE LANG_ENGLISH, SUBLANG_ENGLISH_US
@@ -30,11 +31,11 @@
       BLOCK "040904b0"
       BEGIN
-         VALUE "CompanyName",      "innotek GmbH\0"
+         VALUE "CompanyName",      VBOX_RC_COMPANY_NAME
          VALUE "FileDescription",  "VirtualBox OpenGL ICD\0"
          VALUE "FileVersion",      VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD "." VBOX_SVN_REV "\0"
-         VALUE "InternalName",     "VBoxOGL.dll\0"
-         VALUE "LegalCopyright",   "(C) 2004-2007 innotek GmbH\0"
+         VALUE "InternalName",     "VBoxOGL\0"
+         VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
          VALUE "OriginalFilename", "VBoxOGL.dll\0"
-         VALUE "ProductName",      "VirtualBox Guest Tools\0"
+         VALUE "ProductName",      "xVM VirtualBox Guest Additions\0"
          VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD "." VBOX_SVN_REV "\0"
       END