Index: /trunk/src/VBox/HostDrivers/Support/SUPDRVIOC.h
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/SUPDRVIOC.h	(revision 8113)
+++ /trunk/src/VBox/HostDrivers/Support/SUPDRVIOC.h	(revision 8114)
@@ -178,5 +178,5 @@
  * The upper 16-bit is the major version, the the lower the minor version.
  * When incompatible changes are made, the upper major number has to be changed. */
-#define SUPDRVIOC_VERSION                               0x00070000
+#define SUPDRVIOC_VERSION                               0x00070001
 
 /** SUP_IOCTL_COOKIE. */
Index: /trunk/src/VBox/HostDrivers/Support/SUPDRVShared.c
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/SUPDRVShared.c	(revision 8113)
+++ /trunk/src/VBox/HostDrivers/Support/SUPDRVShared.c	(revision 8114)
@@ -186,10 +186,17 @@
     { "RTThreadUserWaitNoResume",               (void *)RTThreadUserWaitNoResume },
 #endif
+    { "RTLogDefaultInstance",                   (void *)RTLogDefaultInstance },
+    { "RTMpCpuIdFromSetIndex",                  (void *)RTMpCpuIdFromSetIndex },
+    { "RTMpCpuIdToSetIndex",                    (void *)RTMpCpuIdToSetIndex },
+    { "RTMpDoesCpuExist",                       (void *)RTMpDoesCpuExist },
+    { "RTMpGetCount",                           (void *)RTMpGetCount },
+    { "RTMpGetMaxCpuId",                        (void *)RTMpGetMaxCpuId },
+    { "RTMpGetOnlineCount",                     (void *)RTMpGetOnlineCount },
+    { "RTMpGetOnlineSet",                       (void *)RTMpGetOnlineSet },
+    { "RTMpGetSet",                             (void *)RTMpGetSet },
+    { "RTMpIsCpuOnline",                        (void *)RTMpIsCpuOnline },
     { "RTMpOnAll",                              (void *)RTMpOnAll },
     { "RTMpOnOthers",                           (void *)RTMpOnOthers },
     { "RTMpOnSpecific",                         (void *)RTMpOnSpecific },
-    { "RTMpIsCpuOnline",                        (void *)RTMpIsCpuOnline },
-    { "RTMpGetCount",                           (void *)RTMpGetCount },
-    { "RTLogDefaultInstance",                   (void *)RTLogDefaultInstance },
     { "RTLogRelDefaultInstance",                (void *)RTLogRelDefaultInstance },
     { "RTLogSetDefaultInstanceThread",          (void *)RTLogSetDefaultInstanceThread },
Index: /trunk/src/VBox/HostDrivers/Support/SUPLib.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/SUPLib.cpp	(revision 8113)
+++ /trunk/src/VBox/HostDrivers/Support/SUPLib.cpp	(revision 8114)
@@ -209,10 +209,14 @@
         strcpy(CookieReq.u.In.szMagic, SUPCOOKIE_MAGIC);
         CookieReq.u.In.u32ReqVersion = SUPDRVIOC_VERSION;
-        CookieReq.u.In.u32MinVersion = SUPDRVIOC_VERSION & 0xffff0000;
+        const uint32_t MinVersion = (SUPDRVIOC_VERSION & 0xffff0000) == 0x00070000
+                                  ? 0x00070001 /* need new exports */
+                                  : SUPDRVIOC_VERSION & 0xffff0000;
+        CookieReq.u.In.u32MinVersion = MinVersion;
         rc = suplibOsIOCtl(SUP_IOCTL_COOKIE, &CookieReq, SUP_IOCTL_COOKIE_SIZE);
         if (    RT_SUCCESS(rc)
             &&  RT_SUCCESS(CookieReq.Hdr.rc))
         {
-            if ((CookieReq.u.Out.u32SessionVersion & 0xffff0000) == (SUPDRVIOC_VERSION & 0xffff0000))
+            if (    (CookieReq.u.Out.u32SessionVersion & 0xffff0000) == (SUPDRVIOC_VERSION & 0xffff0000)
+                &&  CookieReq.u.Out.u32SessionVersion >= MinVersion)
             {
                 /*
@@ -279,6 +283,6 @@
             else
             {
-                LogRel(("Support driver version mismatch: SessionVersion=%#x DriverVersion=%#x ClientVersion=%#x\n",
-                        CookieReq.u.Out.u32SessionVersion, CookieReq.u.Out.u32DriverVersion, SUPDRVIOC_VERSION));
+                LogRel(("Support driver version mismatch: SessionVersion=%#x DriverVersion=%#x ClientVersion=%#x MinVersion=%#x\n",
+                        CookieReq.u.Out.u32SessionVersion, CookieReq.u.Out.u32DriverVersion, SUPDRVIOC_VERSION, MinVersion));
                 rc = VERR_VM_DRIVER_VERSION_MISMATCH;
             }