Index: trunk/src/VBox/HostDrivers/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostDrivers/Makefile.kmk	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Makefile.kmk	(revision 8155)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2006-2007 innotek GmbH
+# Copyright (C) 2006-2007 Sun Microsystems, Inc.
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,4 +14,8 @@
 # VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 # hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+#
+# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+# Clara, CA 95054 USA or visit http://www.sun.com if you need
+# additional information or have any questions.
 #
 
Index: trunk/src/VBox/HostDrivers/Support/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostDrivers/Support/Makefile.kmk	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/Makefile.kmk	(revision 8155)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2006-2007 innotek GmbH
+# Copyright (C) 2006-2007 Sun Microsystems, Inc.
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
 # You may elect to license modified versions of this file under the
 # terms and conditions of either the GPL or the CDDL or both.
+#
+# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+# Clara, CA 95054 USA or visit http://www.sun.com if you need
+# additional information or have any questions.
 #
 
Index: trunk/src/VBox/HostDrivers/Support/SUPDRV.h
===================================================================
--- trunk/src/VBox/HostDrivers/Support/SUPDRV.h	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/SUPDRV.h	(revision 8155)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/SUPDRVIOC.h
===================================================================
--- trunk/src/VBox/HostDrivers/Support/SUPDRVIOC.h	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/SUPDRVIOC.h	(revision 8155)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/SUPDRVShared.c
===================================================================
--- trunk/src/VBox/HostDrivers/Support/SUPDRVShared.c	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/SUPDRVShared.c	(revision 8155)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/SUPLib.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/SUPLib.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/SUPLib.cpp	(revision 8155)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/SUPLibInternal.h
===================================================================
--- trunk/src/VBox/HostDrivers/Support/SUPLibInternal.h	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/SUPLibInternal.h	(revision 8155)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/SUPR0.def
===================================================================
--- trunk/src/VBox/HostDrivers/Support/SUPR0.def	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/SUPR0.def	(revision 8155)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 innotek GmbH
+; Copyright (C) 2006-2007 Sun Microsystems, Inc.
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
 ; You may elect to license modified versions of this file under the
 ; terms and conditions of either the GPL or the CDDL or both.
+;
+; Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+; Clara, CA 95054 USA or visit http://www.sun.com if you need
+; additional information or have any questions.
 ;
 
Index: trunk/src/VBox/HostDrivers/Support/darwin/SUPDrv-darwin.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/darwin/SUPDrv-darwin.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/darwin/SUPDrv-darwin.cpp	(revision 8155)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/darwin/SUPLib-darwin.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/darwin/SUPLib-darwin.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/darwin/SUPLib-darwin.cpp	(revision 8155)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -24,4 +24,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/darwin/load.sh
===================================================================
--- trunk/src/VBox/HostDrivers/Support/darwin/load.sh	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/darwin/load.sh	(revision 8155)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2006-2007 innotek GmbH
+# Copyright (C) 2006-2007 Sun Microsystems, Inc.
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
 # You may elect to license modified versions of this file under the
 # terms and conditions of either the GPL or the CDDL or both.
+#
+# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+# Clara, CA 95054 USA or visit http://www.sun.com if you need
+# additional information or have any questions.
 #
 
Index: trunk/src/VBox/HostDrivers/Support/freebsd/SUPLib-freebsd.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/freebsd/SUPLib-freebsd.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/freebsd/SUPLib-freebsd.cpp	(revision 8155)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -22,4 +22,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/linux/Makefile
===================================================================
--- trunk/src/VBox/HostDrivers/Support/linux/Makefile	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/linux/Makefile	(revision 8155)
@@ -6,5 +6,5 @@
 #
 #
-# Copyright (C) 2006-2007 innotek GmbH
+# Copyright (C) 2006-2007 Sun Microsystems, Inc.
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -24,4 +24,8 @@
 # You may elect to license modified versions of this file under the
 # terms and conditions of either the GPL or the CDDL or both.
+#
+# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+# Clara, CA 95054 USA or visit http://www.sun.com if you need
+# additional information or have any questions.
 #
 
Index: trunk/src/VBox/HostDrivers/Support/linux/SUPDrv-linux.c
===================================================================
--- trunk/src/VBox/HostDrivers/Support/linux/SUPDrv-linux.c	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/linux/SUPDrv-linux.c	(revision 8155)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -22,4 +22,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  * Some lines of code to disable the local APIC on x86_64 machines taken
  * from a Mandriva patch by Gwenole Beauchesne <gbeauchesne@mandriva.com>.
Index: trunk/src/VBox/HostDrivers/Support/linux/SUPDrv-linux.mod.c
===================================================================
--- trunk/src/VBox/HostDrivers/Support/linux/SUPDrv-linux.mod.c	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/linux/SUPDrv-linux.mod.c	(revision 8155)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -24,4 +24,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/linux/SUPLib-linux.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/linux/SUPLib-linux.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/linux/SUPLib-linux.cpp	(revision 8155)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -24,4 +24,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/linux/build_in_tmp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/linux/build_in_tmp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/linux/build_in_tmp	(revision 8155)
@@ -5,5 +5,5 @@
 # are installed in read-only directory.
 #
-# Copyright (C) 2007 innotek GmbH
+# Copyright (C) 2007 Sun Microsystems, Inc.
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
 # You may elect to license modified versions of this file under the
 # terms and conditions of either the GPL or the CDDL or both.
+#
+# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+# Clara, CA 95054 USA or visit http://www.sun.com if you need
+# additional information or have any questions.
 #
 
Index: trunk/src/VBox/HostDrivers/Support/linux/export_modules
===================================================================
--- trunk/src/VBox/HostDrivers/Support/linux/export_modules	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/linux/export_modules	(revision 8155)
@@ -4,5 +4,5 @@
 # Create a tar archive containing the sources of the vboxdrv kernel module
 #
-# Copyright (C) 2007 innotek GmbH
+# Copyright (C) 2007 Sun Microsystems, Inc.
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -22,4 +22,8 @@
 # You may elect to license modified versions of this file under the
 # terms and conditions of either the GPL or the CDDL or both.
+#
+# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+# Clara, CA 95054 USA or visit http://www.sun.com if you need
+# additional information or have any questions.
 #
 
Index: trunk/src/VBox/HostDrivers/Support/linux/files_vboxdrv
===================================================================
--- trunk/src/VBox/HostDrivers/Support/linux/files_vboxdrv	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/linux/files_vboxdrv	(revision 8155)
@@ -3,5 +3,5 @@
 # Shared file between Makefile.kmk and export_modules
 #
-# Copyright (C) 2007 innotek GmbH
+# Copyright (C) 2007 Sun Microsystems, Inc.
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -21,4 +21,8 @@
 # You may elect to license modified versions of this file under the
 # terms and conditions of either the GPL or the CDDL or both.
+#
+# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+# Clara, CA 95054 USA or visit http://www.sun.com if you need
+# additional information or have any questions.
 #
 
Index: trunk/src/VBox/HostDrivers/Support/os2/SUPDrv-os2.def
===================================================================
--- trunk/src/VBox/HostDrivers/Support/os2/SUPDrv-os2.def	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/os2/SUPDrv-os2.def	(revision 8155)
@@ -4,5 +4,5 @@
 
 ;
-; Copyright (C) 2007 innotek GmbH
+; Copyright (C) 2007 Sun Microsystems, Inc.
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -22,4 +22,8 @@
 ; You may elect to license modified versions of this file under the
 ; terms and conditions of either the GPL or the CDDL or both.
+;
+; Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+; Clara, CA 95054 USA or visit http://www.sun.com if you need
+; additional information or have any questions.
 ;
 
Index: trunk/src/VBox/HostDrivers/Support/os2/SUPLib-os2.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/os2/SUPLib-os2.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/os2/SUPLib-os2.cpp	(revision 8155)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/solaris/SUPDrv-solaris.c
===================================================================
--- trunk/src/VBox/HostDrivers/Support/solaris/SUPDrv-solaris.c	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/solaris/SUPDrv-solaris.c	(revision 8155)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/solaris/SUPLib-solaris.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/solaris/SUPLib-solaris.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/solaris/SUPLib-solaris.cpp	(revision 8155)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostDrivers/Support/testcase/Makefile.kmk	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/testcase/Makefile.kmk	(revision 8155)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2006-2007 innotek GmbH
+# Copyright (C) 2006-2007 Sun Microsystems, Inc.
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
 # You may elect to license modified versions of this file under the
 # terms and conditions of either the GPL or the CDDL or both.
+#
+# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+# Clara, CA 95054 USA or visit http://www.sun.com if you need
+# additional information or have any questions.
 #
 
Index: trunk/src/VBox/HostDrivers/Support/testcase/SUPInstall.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/testcase/SUPInstall.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/testcase/SUPInstall.cpp	(revision 8155)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -24,4 +24,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/testcase/SUPUninstall.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/testcase/SUPUninstall.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/testcase/SUPUninstall.cpp	(revision 8155)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -24,4 +24,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/testcase/tstContiguous.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/testcase/tstContiguous.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/testcase/tstContiguous.cpp	(revision 8155)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -24,4 +24,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/testcase/tstGIP-2.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/testcase/tstGIP-2.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/testcase/tstGIP-2.cpp	(revision 8155)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -24,4 +24,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/testcase/tstGetPagingMode.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/testcase/tstGetPagingMode.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/testcase/tstGetPagingMode.cpp	(revision 8155)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -24,4 +24,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/testcase/tstInit.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/testcase/tstInit.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/testcase/tstInit.cpp	(revision 8155)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -24,4 +24,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/testcase/tstInt.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/testcase/tstInt.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/testcase/tstInt.cpp	(revision 8155)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/testcase/tstLow.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/testcase/tstLow.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/testcase/tstLow.cpp	(revision 8155)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -24,4 +24,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/testcase/tstPage.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/testcase/tstPage.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/testcase/tstPage.cpp	(revision 8155)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -24,4 +24,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/testcase/tstPin.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/testcase/tstPin.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/testcase/tstPin.cpp	(revision 8155)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -24,4 +24,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/win/SUPDrv-win.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/win/SUPDrv-win.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/win/SUPDrv-win.cpp	(revision 8155)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/win/SUPDrvA-win.asm
===================================================================
--- trunk/src/VBox/HostDrivers/Support/win/SUPDrvA-win.asm	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/win/SUPDrvA-win.asm	(revision 8155)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 innotek GmbH
+; Copyright (C) 2006-2007 Sun Microsystems, Inc.
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
 ; You may elect to license modified versions of this file under the
 ; terms and conditions of either the GPL or the CDDL or both.
+;
+; Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+; Clara, CA 95054 USA or visit http://www.sun.com if you need
+; additional information or have any questions.
 ;
 
Index: trunk/src/VBox/HostDrivers/Support/win/SUPLib-win.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/Support/win/SUPLib-win.cpp	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/win/SUPLib-win.cpp	(revision 8155)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2007 innotek GmbH
+ * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -23,4 +23,8 @@
  * You may elect to license modified versions of this file under the
  * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/HostDrivers/Support/win/VBoxDrv.inf
===================================================================
--- trunk/src/VBox/HostDrivers/Support/win/VBoxDrv.inf	(revision 8133)
+++ trunk/src/VBox/HostDrivers/Support/win/VBoxDrv.inf	(revision 8155)
@@ -4,5 +4,5 @@
 ; INF file for installing the Win32 driver
 ;
-; Copyright (C) 2006-2007 innotek GmbH
+; Copyright (C) 2006-2007 Sun Microsystems, Inc.
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -22,4 +22,8 @@
 ; You may elect to license modified versions of this file under the
 ; terms and conditions of either the GPL or the CDDL or both.
+;
+; Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+; Clara, CA 95054 USA or visit http://www.sun.com if you need
+; additional information or have any questions.
 ;
 
Index: trunk/src/VBox/HostDrivers/VBoxTAP/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxTAP/Makefile.kmk	(revision 8133)
+++ trunk/src/VBox/HostDrivers/VBoxTAP/Makefile.kmk	(revision 8155)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2006-2007 innotek GmbH
+# Copyright (C) 2006-2007 Sun Microsystems, Inc.
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,4 +14,8 @@
 # VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 # hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+#
+# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+# Clara, CA 95054 USA or visit http://www.sun.com if you need
+# additional information or have any questions.
 #
 
Index: trunk/src/VBox/HostDrivers/VBoxTAP/VBoxTAP.inf
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxTAP/VBoxTAP.inf	(revision 8133)
+++ trunk/src/VBox/HostDrivers/VBoxTAP/VBoxTAP.inf	(revision 8155)
@@ -3,5 +3,5 @@
 ;
 ;
-; Copyright (C) 2006-2007 innotek GmbH
+; Copyright (C) 2006-2007 Sun Microsystems, Inc.
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -12,4 +12,8 @@
 ; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 ; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+;
+; Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+; Clara, CA 95054 USA or visit http://www.sun.com if you need
+; additional information or have any questions.
 ;
 